<?php

if(!defined('_VALID_MOS') && !defined('_JEXEC')) die('Direct Access to '.basename(__FILE__).' is not allowed.');

if (!class_exists('vmPSPlugin'))
{
    require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
}

class plgVMPaymentEasyPay extends vmPSPlugin
{
	
	public static $_this = false;
	
	function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
	    $this->_loggable = true;
	    $this->tableFields = array_keys($this->getTableSQLFields());		
	    $varsToPush = array(
	    	'payment_logos' => array('', 'char'),
	    	'debug'   	    => array('', 'char'),
	    	'merchant'      => array('', 'char'),
	    	'web_key'       => array('', 'char'),
	    	'comment'       => array('', 'string'),
	    	'expiried'      => array(3,  'int'),
	    	'server'        => array('',  'char')
		);

		$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
    }
    
//создание таблицы для хранения заказов сделанных с помощью easypay
    protected function getVmPluginCreateTableSQL()
    {
		return $this->createTableSQL('Payment EasyPay Table');
    }
    
    function getTableSQLFields()
    {
		$SQLfields = array(
	    	'id' 						  => 'tinyint(1) unsigned NOT NULL AUTO_INCREMENT',
	    	'virtuemart_order_id'         => 'int(11) UNSIGNED DEFAULT NULL',
	    	'order_number'                => 'char(32) DEFAULT NULL',
	    	'virtuemart_paymentmethod_id' => 'mediumint(1) UNSIGNED DEFAULT NULL',
	    	'payment_name' 				  => 'char(255) NOT NULL DEFAULT \'\' ',
	    	'payment_order_total'         => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\' ',
	    	'payment_currency' 			  => 'char(3) ',
	    	'cost_per_transaction' 		  => 'decimal(10,2) DEFAULT NULL ',
	    	'cost_percent_total' 		  => 'decimal(10,2) DEFAULT NULL ',
	    	'tax_id' 					  => 'smallint(11) DEFAULT NULL'
		);

	return $SQLfields;
    }
    
    function plgVmConfirmedOrder($cart, $order) 
    {
		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id)))
		{
	    	return null;
		}
		if (!$this->selectedThisElement($method->payment_element))
		{
	    	return false;
		}
		
		$session = JFactory::getSession();
		$return_context = $session->getId();
		$this->_debug = $method->debug;
		$this->logInfo('plgVmConfirmedOrder order number: ' . $order['details']['BT']->order_number, 'message');
		
		if (!class_exists('VirtueMartModelOrders'))
		{
	    	require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		}
	    if (!class_exists('VirtueMartModelCurrency'))
	    {
	    	require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');
	    }	    
		$new_status = $method->status_success;		    	
		$vendorModel = new VirtueMartModelVendor();
		$vendorModel->setId(1);
		$vendor = $vendorModel->getVendor();
		$this->getPaymentCurrency($method);
		$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
		$db = &JFactory::getDBO();
		$db->setQuery($q);
		$currency_code_3 = $db->loadResult();
		$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
		$totalInPaymentCurrency = $paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total,false);
		$cd = CurrencyDisplay::getInstance($cart->pricesCurrency);
		
//Формирование POST заголовка для отправки на easypay	
		$post_variables = Array(
			'EP_MerNo'       => $method->merchant,
			'EP_OrderNo'     => $order['details']['BT']->order_number,
			'EP_Sum'         => $totalInPaymentCurrency,
			'EP_Expires'     => $method->expiried,
			'EP_Comment'     => "Заказ от магазина ".$method->comment, //комментарий счета (до 50 симв.)
			'EP_OrderInfo'   => "Заказ №".$order['details']['BT']->order_number,
	    	'EP_Hash'        => md5 ($method->merchant . $method->web_key . $order['details']['BT']->order_number . $totalInPaymentCurrency),
			'EP_Success_URL' => JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id),
	    	'EP_Cancel_URL'  => JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginUserPaymentCancel&on=' . $order['details']['BT']->order_number . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id),
	    	'EP_Notify_URL'  => JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&tmpl=component'),
			'EP_Debug'       => $method->debug,
			'EP_Encoding'	 => 'utf-8',
		);

	   	$url = $method->server;  	
	
		$this->_virtuemart_paymentmethod_id      = $order['details']['BT']->virtuemart_paymentmethod_id;
		$dbValues['payment_name']                = $this->renderPluginName($method);
		$dbValues['order_number']                = $order['details']['BT']->order_number;
		$dbValues['virtuemart_paymentmethod_id'] = $this->_virtuemart_paymentmethod_id;
		$dbValues['cost_per_transaction']        = $method->cost_per_transaction;
		$dbValues['cost_percent_total']          = $method->cost_percent_total;
		$dbValues['payment_currency']            = $currency_code_3 ;
		$dbValues['payment_order_total']         = $totalInPaymentCurrency;
		$dbValues['tax_id']                      = $method->tax_id;
		$this->storePSPluginInternalData($dbValues);

		$html = '<form action="' . $url . '" method="post" name="vm_easypay_form">';
		
		foreach ($post_variables as $name => $value)
		{
	    	$html.= '<input type="hidden" name="' . $name . '" value="' . htmlspecialchars($value) . '" />';
		}
		
		$html.= '</form>';

		$html.= ' <script type="text/javascript">';
		$html.= ' document.vm_easypay_form.submit();';
		$html.= ' </script>';

		return $this->processConfirmedOrderPaymentResponse(1, $cart, $order, $html, '', $new_status);
    } 
    
//Отображение информации о заказе в админке   
	function plgVmOnShowOrderBEPayment($virtuemart_order_id, $virtuemart_payment_id)
	{
		if (!$this->selectedThisByMethodId($virtuemart_payment_id))
		{
	    	return null;
		}
    
		$db = JFactory::getDBO();
		$q = 'SELECT * FROM `' . $this->_tablename . '` '
			. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery($q);
		if (!($paymentTable = $db->loadObject()))
		{
	    	vmWarn(500, $q . " " . $db->getErrorMsg());
	    	return '';
		}
		$this->getPaymentCurrency($paymentTable);

		$html = '<table class="adminlist">' . "\n";
		$html .=$this->getHtmlHeaderBE();
		$html .= $this->getHtmlRowBE('EASYPAY_PAYMENT_NAME', $paymentTable->payment_name);
		$html .= '</table>' . "\n";
		return $html;
    }

    function getCosts(VirtueMartCart $cart, $method, $cart_prices)
    {
		if (preg_match('/%$/', $method->cost_percent_total))
		{
	    	$cost_percent_total = substr($method->cost_percent_total, 0, -1);
		} 
		else
		{
	    	$cost_percent_total = $method->cost_percent_total;
		}
		return (ceil($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01)));
    }
    
    protected function checkConditions($cart, $method, $cart_prices)
    {
		$address = (($cart->ST == 0) ? $cart->BT : $cart->ST);

		$amount = $cart_prices['salesPrice'];
		$amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount
			OR
			($method->min_amount <= $amount AND ($method->max_amount == 0) ));
		if (!$amount_cond)
		{
	    	return false;
		}
		$countries = array();
		if (!empty($method->countries))
		{
	    	if (!is_array($method->countries))
	    	{
				$countries[0] = $method->countries;
	    	}
	    	else
	    	{
				$countries = $method->countries;
	    	}
		}
		if (!is_array($address))
		{
		    $address = array();
		    $address['virtuemart_country_id'] = 0;
		}

		if (!isset($address['virtuemart_country_id']))
		{
		    $address['virtuemart_country_id'] = 0;
		}
		if (count($countries) == 0 || in_array($address['virtuemart_country_id'], $countries) || count($countries) == 0)
		{
		    return true;
		}

		return false;
    }

//Отсылка уведомления продавцу после завершения оплаты    
    function plgVmOnPaymentResponseReceived(  &$html)
    {
		$virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
		$vendorId = 0;
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id)))
		{
	    	return null;
		}
		if (!$this->selectedThisElement($method->payment_element))
		{
	    	return false;
		}
		$payment_data = JRequest::get('post');
		vmdebug('plgVmOnPaymentResponseReceived', $payment_data);
		$order_number = $payment_data['invoice'];
		$return_context = $payment_data['custom'];
		if (!class_exists('VirtueMartModelOrders'))
		{
	    	require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		}
		$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);
		$payment_name = $this->renderPluginName($method);
		$html = "Оплата заказа прошла успешно.";
	    if ($virtuemart_order_id)
	    {
			if (!class_exists('VirtueMartCart'))
			{
			    require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
			}
			$cart = VirtueMartCart::getCart();
			if (!class_exists('VirtueMartModelOrders'))
			{
			    require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
			}
			$order = new VirtueMartModelOrders();
			$orderitems = $order->getOrder($virtuemart_order_id);
			$cart->sentOrderConfirmedEmail($orderitems);

			$cart->emptyCart();
		}
		return true;
    }

//отмена и удаление выписанного счета при нажатии на кнопку "<<Назад в магазин"     
    function plgVmOnUserPaymentCancel()
    {
		if (!class_exists('VirtueMartModelOrders'))
		{
	    	require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		}
		$order_number = JRequest::getVar('on');
		if (!$order_number)
		{
	    	return false;
		}
		$db = JFactory::getDBO();
		$query = 'SELECT ' . $this->_tablename . '.`virtuemart_order_id` FROM ' . $this->_tablename. " WHERE  `order_number`= '" . $order_number . "'";
		$db->setQuery($query);
		$virtuemart_order_id = $db->loadResult();

		if (!$virtuemart_order_id)
		{
	    	return null;
		}
		$params = Array (
			'ORDER'  => $order_number,
			'ACTION' => 'canceled'
		);
		$this->logingActions($params);
		$this->handlePaymentUserCancel($virtuemart_order_id);

		return true;
    }

//Изменение статуса заказа на Confirmed после оплаты счета   
    function plgVmOnPaymentNotification()
    {
		if (!class_exists('VirtueMartModelOrders'))
		{
	    	require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		}
		$easypay_data = JRequest::get('post');
		$order_mer_code = $easypay_data['order_mer_code'];
		$sum = $easypay_data['sum'];
		$mer_no = $easypay_data['mer_no'];
		$card = $easypay_data['card'];
		$purch_date = $easypay_data['purch_date'];
		$db = JFactory::getDBO();
		$query = "SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_orders` WHERE `order_number` ='" . $order_mer_code	. "'";
		$db->setQuery($query);
		$paymentmethod = $db->loadResult();
		$query = "SELECT `payment_params` FROM `#__virtuemart_paymentmethods` WHERE `virtuemart_paymentmethod_id` ='" . $paymentmethod .  "'";
		$db->setQuery($query);
		$params = $db ->loadResult();
		$raw_web_key = explode("|", $params);
		$raw_web_key = explode("=", $raw_web_key[3]);
		$web_key = substr($raw_web_key[1], 1, strlen($raw_web_key[1])-2);
		$notify_signature = $easypay_data['notify_signature'];
		$sig = md5 ($order_mer_code . $sum . $mer_no . $card . $purch_date . $web_key);
		$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_mer_code);
		if ($sig == $notify_signature){
			$db = JFactory::getDBO();
			$query = "UPDATE `#__virtuemart_orders` SET `order_status` = 'C' WHERE `virtuemart_order_id` ='" . $virtuemart_order_id . "'";
			$db->setQuery($query);
			$db->query();
			$params = Array (
				'ORDER'  => $order_mer_code,
				'ACTION' => 'confirmed'
			);
			$this->logingActions($params);
			header("HTTP/1.0 200 OK"); // генерация HTTP-заголовка
		}else{
			header("HTTP/1.0 400 Bad Request");
		}
		return true;
    }    
    
    function plgVmOnStoreInstallPaymentPluginTable($jplugin_id)
    {
		return $this->onStoreInstallPluginTable($jplugin_id);
    }
    
    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart)
    {
		return $this->OnSelectCheck($cart);
    }
    
	public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
		return $this->displayListFE($cart, $selected, $htmlIn);
    }	
	
    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name)
    {
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }
    
    function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId)
    {

		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id)))
		{
	    	return null;
		}
		if (!$this->selectedThisElement($method->payment_element))
		{
	    	return false;
		}
	 	$this->getPaymentCurrency($method);

		$paymentCurrencyId = $method->payment_currency;
    }
    
    function logingActions($params)
    {
    	jimport('joomla.error.log');
    	$options = array(
    		'format' => "{DATE}\t{TIME}\t{ORDER}\t{ACTION}"
		);
    	$log = &JLog::getInstance('easypay_events.log.php', $options);
    	$log->addEntry(array('ORDER' => $params['ORDER'],'ACTION' => $params['ACTION']));
    }
    
    function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array())
    {
		return $this->onCheckAutomaticSelected($cart, $cart_prices);
    }
    
    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name)
    {
		$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }
    
    function plgVmonShowOrderPrintPayment($order_number, $method_id)
    {
		return $this->onShowOrderPrint($order_number, $method_id);
    }

    function plgVmDeclarePluginParamsPayment($name, $id, &$data)
    {
		return $this->declarePluginParams('payment', $name, $id, $data);
    }

    function plgVmSetOnTablePluginParamsPayment($name, $id, &$table)
    {
		return $this->setOnTablePluginParams($name, $id, $table);
    }
}






?>